> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Create Personal Access Token

> Creates a new personal access token for API authentication.

`Unary` · [`Users`](/docs/api-reference/generated/user/overview)

Creates a new personal access token for API authentication.

Use this method to:

* Generate API access tokens
* Create service account credentials
* Set up automated access

### Examples

* Create token:

  Creates a new access token valid for 30 days.

  ```yaml theme={null}
  userId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  description: "CI/CD Pipeline Token"
  validFor: "2592000s"  # 30 days
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.UserService/CreatePersonalAccessToken
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.UserService/CreatePersonalAccessToken" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "userId": "<user-id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.user_pb2 as user_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = user_pb2.CreatePersonalAccessTokenRequest(
      user_id="<user-id>",
  )
  response = ona.services.user.create_personal_access_token(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { CreatePersonalAccessTokenRequestSchema } from "@gitpod/sdk/gitpod/v1/user_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(CreatePersonalAccessTokenRequestSchema, {
      userId: "<user-id>",
    });
    const response = await ona.services.user.createPersonalAccessToken(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.CreatePersonalAccessTokenRequest{
  		UserId: "<user-id>",
  	})
  	response, err := ona.Services.User.CreatePersonalAccessToken(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "userId": "<user-id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.CreatePersonalAccessTokenRequest`

| Field         | Type            | Required | Description                                                                                            |
| ------------- | --------------- | -------- | ------------------------------------------------------------------------------------------------------ |
| `userId`      | string          | No       | Constraints: `string.uuid=true`.                                                                       |
| `description` | string          | No       |                                                                                                        |
| `validFor`    | duration string | No       | Constraints: `duration.lte.seconds=7776000`.                                                           |
| `readOnly`    | boolean         | No       | When true, the token can only be used for read operations. Mutations will be denied at the data layer. |

## Response

`gitpod.v1.CreatePersonalAccessTokenResponse`

| Field   | Type   | Required | Description                   |
| ------- | ------ | -------- | ----------------------------- |
| `token` | string | Yes      | Constraints: `required=true`. |
